--CRASH MAN FOREVER

require "class"
require "angle"
require "font"
require "star"
require "mega"
require "crash"
require "shot"
require "bomb"
require "boom"

function love.load()
	
	loadFont()
	
	img = {} --load all them images
	img["background"] = love.graphics.newImage("/img/background.png")
	img["background2"] = love.graphics.newImage("/img/background2.png")
	img["hp_m"] = love.graphics.newImage("/img/hp_m.png")
	img["hp_c"] = love.graphics.newImage("/img/hp_c.png")
	img["pause"] = love.graphics.newImage("/img/pause.png")
	img["mega_r"] = love.graphics.newImage("/img/mega_r.png")
	img["mega_l"] = love.graphics.newImage("/img/mega_l.png")
	img["mega_sr"] = love.graphics.newImage("/img/mega_sr.png")
	img["mega_sl"] = love.graphics.newImage("/img/mega_sl.png")
	img["mega_jr"] = love.graphics.newImage("/img/mega_jr.png")
	img["mega_jl"] = love.graphics.newImage("/img/mega_jl.png")
	img["mega_w1r"] = love.graphics.newImage("/img/mega_w1r.png")
	img["mega_w1l"] = love.graphics.newImage("/img/mega_w1l.png")
	img["mega_w2r"] = love.graphics.newImage("/img/mega_w2r.png")
	img["mega_w2l"] = love.graphics.newImage("/img/mega_w2l.png")
	img["mega_w3r"] = love.graphics.newImage("/img/mega_w3r.png")
	img["mega_w3l"] = love.graphics.newImage("/img/mega_w3l.png")
	img["mega_hr"] = love.graphics.newImage("/img/mega_hr.png")
	img["mega_hl"] = love.graphics.newImage("/img/mega_hl.png")
	img["mega_fr"] = love.graphics.newImage("/img/mega_fr.png")
	img["mega_fl"] = love.graphics.newImage("/img/mega_fl.png")
	img["mega_fjr"] = love.graphics.newImage("/img/mega_fjr.png")
	img["mega_fjl"] = love.graphics.newImage("/img/mega_fjl.png")
	img["mega_fw1r"] = love.graphics.newImage("/img/mega_fw1r.png")
	img["mega_fw1l"] = love.graphics.newImage("/img/mega_fw1l.png")
	img["mega_fw2r"] = love.graphics.newImage("/img/mega_fw2r.png")
	img["mega_fw2l"] = love.graphics.newImage("/img/mega_fw2l.png")
	img["mega_fw3r"] = love.graphics.newImage("/img/mega_fw3r.png")
	img["mega_fw3l"] = love.graphics.newImage("/img/mega_fw3l.png")
	img["crash_r"] = love.graphics.newImage("/img/crash_r.png")
	img["crash_l"] = love.graphics.newImage("/img/crash_l.png")
	img["crash_j1r"] = love.graphics.newImage("/img/crash_j1r.png")
	img["crash_j1l"] = love.graphics.newImage("/img/crash_j1l.png")
	img["crash_w1r"] = love.graphics.newImage("/img/crash_w1r.png")
	img["crash_w1l"] = love.graphics.newImage("/img/crash_w1l.png")
	img["crash_w2r"] = love.graphics.newImage("/img/crash_w2r.png")
	img["crash_w2l"] = love.graphics.newImage("/img/crash_w2l.png")
	img["crash_w3r"] = love.graphics.newImage("/img/crash_w3r.png")
	img["crash_w3l"] = love.graphics.newImage("/img/crash_w3l.png")
	img["star1"] = love.graphics.newImage("/img/star1.png")
	img["star2"] = love.graphics.newImage("/img/star2.png")
	img["star3"] = love.graphics.newImage("/img/star3.png")
	img["star4"] = love.graphics.newImage("/img/star4.png")
	img["star5"] = love.graphics.newImage("/img/star5.png")
	img["star6"] = love.graphics.newImage("/img/star6.png")
	img["shot"] = love.graphics.newImage("/img/shot.png")
	img["bomb_r"] = love.graphics.newImage("/img/bomb_r.png")
	img["bomb_l"] = love.graphics.newImage("/img/bomb_l.png")
	img["bomb1_r"] = love.graphics.newImage("/img/bomb1_r.png")
	img["bomb1_l"] = love.graphics.newImage("/img/bomb1_l.png")
	img["bomb2_r"] = love.graphics.newImage("/img/bomb2_r.png")
	img["bomb2_l"] = love.graphics.newImage("/img/bomb2_l.png")
	img["explosion1"] = love.graphics.newImage("/img/explosion1.png")
	img["explosion2"] = love.graphics.newImage("/img/explosion2.png")
	img["explosion3"] = love.graphics.newImage("/img/explosion3.png")
	img["pchow"] = love.graphics.newImage("/img/pchow.png")
	img["icon"] = love.graphics.newImage("/img/icon.png")
	
	love.graphics.setIcon(img["icon"])
	
	--sound
	volume = 1
	love.audio.setVolume(volume)
	shoot = love.audio.newSource("shoot.ogg")
	explode = love.audio.newSource("explode.ogg")
	hit = love.audio.newSource("hit.ogg")
	dmg = love.audio.newSource("dmg.ogg")
	charge = love.audio.newSource("charge.ogg")
	charge:setLooping(true)
	die = love.audio.newSource("die.ogg")
	die:setVolume(0.9)
	ting = love.audio.newSource("ting.ogg")
	
	oldbgm = love.audio.newSource("oldbgm.ogg")
	oldbgm:setPitch(0.5)
	oldbgm:setLooping(true)
	oldbgm:play()
	voldbgm = 1
	
	fadeout1 = 5
	fadeout2 = 2
	
	--music
	sq1 = love.audio.newSource("sq1.ogg")
	sq1:setLooping(true)
	vsq1 = 0
	sq1:play(); sq1:pause()
	sq2 = love.audio.newSource("sq2.ogg")
	sq2:setLooping(true)
	vsq2 = 0
	sq2:play(); sq2:pause()
	tri = love.audio.newSource("tri.ogg")
	tri:setLooping(true)
	vtri = 0
	tri:play(); tri:pause()
	noi = love.audio.newSource("noi.ogg")
	noi:setLooping(true)
	vnoi = 0
	noi:play(); noi:pause()
	--pause all tracks immediately after starting them.
	--that way they all get unpaused at the same time and sync up.
	
	obj = {}
	
	hits = 0 --gameplay/stats
	kills = 0
	timeElapsed = 0
	
	stars = {}
	starTimer = -1
	
	mode = "start" --gamestate
	paused = false
	intro = true --stop movement while crashman charges health
	endGame = false
	
	cx = -512
	cy = 0
	
	dt = 0.01
	accum = 0
	frame = 0
	
end

function love.update(delta)
	frame = frame + 1
	accum = accum + delta
	if accum > 0.05 then accum = 0.05 end
	while accum >= delta do
		
		updateBGM()
		
		if mode == "start" then --camera shenanigans
			if cx>-512 then cx = cx - 500*dt end
			if cx<-512 then --reset all music when sliding back to start menu
				cx = -512
				oldbgm:rewind()
				voldbgm = 1
				
				sq1:rewind(); sq1:pause()
				sq2:rewind(); sq2:pause()
				tri:rewind(); tri:pause()
				noi:rewind(); noi:pause()
				
			end
		end
		if mode == "play" then
			if cx<0 then cx = cx + 500*dt end
			if cx>0 then --start bgm when sliding to game screen
				cx = 0
				sq1:resume()
				sq2:resume()
				tri:resume()
				noi:resume()
			end
		end
		if not paused and mode == "play" and cx == 0 then
		local i = 1
		timeElapsed = timeElapsed + dt
		while i <= table.getn(obj) do --update everything
			obj[i]:update(dt)
			if obj[i].col then collide(i) end
			if obj[i].die then table.remove(obj,i); i = i - 1 end
			i = i + 1
		end
		if endGame then obj = {}; endGame = false; intro = true end
		
		else
			--paused (nothing important happens here)
		end
		if not paused then
		--spawn stars
		starTimer = starTimer - dt
		if starTimer < 0 then
			local found = false
			while not found do
				found = true
				starx = math.floor((math.random()*444)/12)*12+34
				stary = math.floor((math.random()*378)/12)*12+2
				for i=1, table.getn(stars) do
					if stars[i].x == starx and stars[i].y == stary then found = false end
				end
			end
			stars[table.getn(stars)+1] = star:new({starx, stary})
			starTimer = 0.01
		end
		local i = 1
		while i <= table.getn(stars) do
			stars[i]:update(dt)
			if stars[i].die then table.remove(stars,i); i = i - 1 end
			i = i + 1
		end
		end
		
		accum = accum - 0.01
	end
	if accum>0.1 then accum = 0 end
end

function love.draw()
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(img["background2"],math.floor(-512-cx),math.floor(-cy))
	love.graphics.draw(img["background"],math.floor(-cx),math.floor(-cy))
	for i=1, table.getn(stars) do
		love.graphics.setColor(255,255,255,stars[i].alpha)
		love.graphics.draw(stars[i].img, math.floor(stars[i].x-cx), math.floor(stars[i].y-cy))
	end
	if mode == "play" then
		--draw hp
		love.graphics.setColor(255,255,255,255)
		for i=1, obj[1].hp do
			love.graphics.draw(img["hp_m"], 48, 154-4*i)
		end
		for i=1, table.getn(obj) do
			if obj[i].id == "crash" then
				for j=1, obj[i].hp do
					love.graphics.draw(img["hp_c"], 72, 154-4*j)
				end
			end
		end
	end
	--draw objects
	for i=1, table.getn(obj) do
		love.graphics.setColor(255,255,255,obj[i].alpha)
		love.graphics.draw(obj[i].img, math.floor(obj[i].x-obj[i].ox-cx), math.floor(obj[i].y-obj[i].oy-cy))
		for j=1, table.getn(obj[i].add) do
			if obj[i].add[j][4] ~= 0 then --why bother drawing it if it's invisible
				love.graphics.setColor(255,255,255,obj[i].add[j][4])
				love.graphics.draw(obj[i].add[j][1], math.floor(obj[i].add[j][2]), math.floor(obj[i].add[j][3]))
			end
		end
	end
	love.graphics.setColor(255,255,255)
	if paused then --pause screen
		love.graphics.draw(img["pause"], 204-cx-32, 172-32)
		for i=1, string.len("PAUSE") do
			love.graphics.draw(chars[string.sub("PAUSE",i,i)],204-cx+(i-1)*16, 172)
		end
	end
	--main menu text
	if mode == "start" then
		if timeElapsed > 0 then
			for i=1, string.len(endText1) do
				love.graphics.draw(chars[string.sub(endText1,i,i)],-512+60-cx+(i-1)*16, 156)
			end
			for i=1, string.len(endText2) do
				love.graphics.draw(chars[string.sub(endText2,i,i)],-512+60-cx+(i-1)*16, 172)
			end
		else
			for i=1, string.len("CRASH MAN FOREVER") do
				love.graphics.draw(chars[string.sub("CRASH MAN FOREVER",i,i)],-512+108-cx+(i-1)*16, 172)
			end
		end
		for i=1, string.len("PRESS START") do
			love.graphics.draw(chars[string.sub("PRESS START",i,i)],-512+156-cx+(i-1)*16, 380)
		end
	end
	love.graphics.setColor(255,50,50,100)
end

function updateBGM() --volumes
	if mode == "start" then
		vsq1 = 0
		vsq2 = 0
		vtri = 0
		vnoi = 0
	end
	if mode == "play" then
		voldbgm = 0
		vnoi = 1
		if obj[1].hp == 2 then
			vsq1 = 0
			vsq2 = 4
		end
		if paused then
			vsq1 = 0
			vsq2 = 0
		else
			vsq1 = 1
			vsq2 = 1
			if obj[1].hp == 2 then
				vsq1 = 0
				vsq2 = 4
			end
		end
		if intro then
			vtri = 0
			vsq2 = 0
		else
			vtri = 1
		end
	end
	
	sq1:setVolume(sq1:getVolume() + (vsq1-sq1:getVolume())*fadeout1*dt) --fadeout1
	sq2:setVolume(sq2:getVolume() + (vsq2-sq2:getVolume())*fadeout1*dt)
	tri:setVolume(tri:getVolume() + (vtri-tri:getVolume())*fadeout1*dt)
	noi:setVolume(noi:getVolume() + (vnoi-noi:getVolume())*fadeout1*dt)
	
	oldbgm:setVolume(oldbgm:getVolume() + (voldbgm-oldbgm:getVolume())*fadeout1*dt) --fadeout2
end

function collide(num) --collisions for all the things* (*that are rectangles)
	local all = {}
	local counter = {}
	for i=1, table.getn(obj) do counter[i] = 0 end
	for i=1, table.getn(obj) do
		ceaseCollisions = false
		if id ~= i and math.abs(obj[num].x-obj[i].x) < obj[i].w+obj[num].w then --only collide w/close things and not w/self
			if obj[num].y+obj[num].h>obj[i].y and obj[num].y<obj[i].y+obj[i].h then --left/right
				if obj[num].px+obj[num].w <= obj[i].px and obj[num].x+obj[num].w > obj[i].x and ceaseCollisions == false then --left
					all[table.getn(all)+1] = ({"left",i})
					counter[i] = counter[i] + 1 --count how many collisions it has w/a single object
				end
				if obj[num].px >= obj[i].px+obj[i].w and obj[num].x < obj[i].x+obj[i].w and ceaseCollisions == false then --right
					all[table.getn(all)+1] = ({"right",i})
					counter[i] = counter[i] + 1
				end
			end
			if obj[num].x+obj[num].w>obj[i].x and obj[num].x<obj[i].x+obj[i].w then --up/down
				if obj[num].py+obj[num].h <= obj[i].py and obj[num].y+obj[num].h > obj[i].y and ceaseCollisions == false then --from above
					all[table.getn(all)+1] = ({"up",i})
					counter[i] = counter[i] + 1
				end
				if obj[num].py >= obj[i].py+obj[i].h and obj[num].y < obj[i].y+obj[i].h and ceaseCollisions == false then --below
					all[table.getn(all)+1] = ({"down",i})
					counter[i] = counter[i] + 1
				end
			end
			if counter[i] == 0 then
				if obj[num].y+obj[num].h>obj[i].y and obj[num].y<obj[i].y+obj[i].h and obj[num].x+obj[num].w>obj[i].x and obj[num].x<obj[i].x+obj[i].w then
					all[table.getn(all)+1] = ({"in",i})
					counter[i] = counter[i] + 1
				end
			end
		end
	end
	local priority = false
	for i=1, table.getn(counter) do
		if counter[i] == 1 then priority = true end --ignore all double collisions as long as there is at least one single collision
	end
	for i=1, table.getn(all) do
		if counter[all[i][2]] == 1 then obj[num]:collide(all[i]) end
		if counter[all[i][2]] > 1 and priority == false then obj[num]:collide(all[i]) end
	end
end

function love.keypressed(key)
	if (not paused) and (not intro) and mode == "play" then
		if key=="z" and obj[1].onGround and obj[1].invuln<=obj[1].knockbackTime then obj[1].vy = -obj[1].jumpForce end
		if key=="x" then
			obj[1]:shoot()
			for i=1, table.getn(obj) do
				if obj[i].id == "crash" then obj[i]:jump() end
			end
		end
		if key == "-" then love.audio.setVelocity(love.audio.getVelocity()-0.1); dt = love.audio.getVelocity()*0.01 end
		if key == "=" then love.audio.setVelocity(love.audio.getVelocity()+0.1); dt = love.audio.getVelocity()*0.01 end
	end
	if key == "m" then if volume == 1 then volume = 0 else volume = 1 end; love.audio.setVolume(volume) end
	if key == "return" and mode == "play" then
		paused = not paused
		if paused then
			shoot:pause();explode:pause();hit:pause();dmg:pause();charge:pause();die:pause()
		else
			shoot:resume();explode:resume();hit:resume();dmg:resume();charge:resume();die:resume()
		end
	end
	if key == "return" and mode == "start" then
		mode = "play"
		kills = 0
		timeElapsed = 0
		obj[1] = mega:new()
		obj[2] = crash:new()
		fadeout1 = 5
		fadeout2 = 2
	end
	if key == "escape" then love.event.quit() end
end