boom = class:new()

function boom:init(args)
	self.x = args[1]
	self.y = args[2]
	self.ox = 16 --16 for explosion1, 12 for explosion2, 8 for explosion3
	self.oy = 16
	self.w = 32 --this stuff doesn't matter
	self.h = 32
	self.px = self.x
	self.py = self.y
	self.vx = args[3]
	self.vy = args[4]
	self.i = args[6]
	self.mag = 50+(self.i)*50
	local angle = angle:new({self.vx,-self.vy})
	angle:setTheta(angle.theta+(3-self.i)*(math.pi/8))
	self.vx = (angle.xPart)*self.mag
	self.vy = (angle.yPart)*self.mag
	self.die = false
	self.col = false
	self.id = "boom"
	self.imgnum = 1
	self.img = img["explosion1"]
	self.timer = 0.1
	self.spawnTimer = args[5]
	self.add = {}
	self.alpha = 0
end

function boom:update(dt)
	self.px = self.x
	self.py = self.y
	
	self.spawnTimer = self.spawnTimer - dt
	
	if self.spawnTimer < 0 then
		self.alpha = 255
		self.x = self.x + self.vx*dt
		self.y = self.y + self.vy*dt
	end
	
	self.timer = self.timer - dt
	if self.timer < 0 then
		self.timer = self.timer + 0.1
		if self.imgnum == 1 then self.img = img["explosion2"]; self.ox = 12; self.oy = 12 end
		if self.imgnum == 2 then self.img = img["explosion3"]; self.ox = 8; self.oy = 8 end
		if self.imgnum == 3 then self.img = img["explosion1"]; self.ox = 16; self.oy = 16 end
		self.imgnum = self.imgnum + 1
		if self.imgnum > 3 then self.imgnum = 1 end
	end
	
	if self.x+self.w < 0 or self.x > 512 or self.y+self.h<0 or self.y>480 then self.die = true end
end